﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Win32;
using NUnit.Framework;

namespace ReadWriteRegistryDemo
{
    [TestFixture]
    public class TestHarness
    {
        [Test]
        public void RegistryTests()
        {
            var hive = Registry.CurrentUser.CreateSubKey("DimecastDemo");
            var registryWriter = new RegistryWriter(hive);

            var key = "Demo";
            var value = "SomeValue";
            //registryWriter.WriteValue(key, value);
            //registryWriter.CreateSubFolder("Demo");
            //registryWriter.DeleteValue(key);

            var registryReader = new RegistryReader(hive);

            string returnedValue = registryReader.GetValue(key);
        }
    }

    public class RegistryReader
    {
        private RegistryKey Hive { get; set; }

        public RegistryReader(RegistryKey hive)
        {
            Hive = hive;
        }

        public string GetValue(string key)
        {
            return Hive.GetValue(key).ToString();
        }
    }

    public class RegistryWriter
    {
        private RegistryKey Hive { get; set; }

        public RegistryWriter(RegistryKey hive)
        {
            Hive = hive;
        }

        public void WriteValue(string key, string value)
        {
            Hive.SetValue( key, value );
        }

        public void CreateSubFolder(string folderName)
        {
            Hive.CreateSubKey(folderName);
        }

        public void DeleteValue(string key)
        {
            Hive.DeleteSubKey(key);
        }
    }
}
